deps.mk 21 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624
  1. # Copyright (c) 2013-2016, Loïc Hoguin <essen@ninenines.eu>
  2. # This file is part of erlang.mk and subject to the terms of the ISC License.
  3. .PHONY: distclean-deps clean-tmp-deps.log
  4. # Configuration.
  5. ifdef OTP_DEPS
  6. $(warning The variable OTP_DEPS is deprecated in favor of LOCAL_DEPS.)
  7. endif
  8. IGNORE_DEPS ?=
  9. export IGNORE_DEPS
  10. APPS_DIR ?= $(CURDIR)/apps
  11. export APPS_DIR
  12. DEPS_DIR ?= $(CURDIR)/deps
  13. export DEPS_DIR
  14. REBAR_DEPS_DIR = $(DEPS_DIR)
  15. export REBAR_DEPS_DIR
  16. # External "early" plugins (see core/plugins.mk for regular plugins).
  17. # They both use the core_dep_plugin macro.
  18. define core_dep_plugin
  19. ifeq ($(2),$(PROJECT))
  20. -include $$(patsubst $(PROJECT)/%,%,$(1))
  21. else
  22. -include $(DEPS_DIR)/$(1)
  23. $(DEPS_DIR)/$(1): $(DEPS_DIR)/$(2) ;
  24. endif
  25. endef
  26. DEP_EARLY_PLUGINS ?=
  27. $(foreach p,$(DEP_EARLY_PLUGINS),\
  28. $(eval $(if $(findstring /,$p),\
  29. $(call core_dep_plugin,$p,$(firstword $(subst /, ,$p))),\
  30. $(call core_dep_plugin,$p/early-plugins.mk,$p))))
  31. dep_name = $(if $(dep_$(1)),$(1),$(if $(pkg_$(1)_name),$(pkg_$(1)_name),$(1)))
  32. dep_repo = $(patsubst git://github.com/%,https://github.com/%, \
  33. $(if $(dep_$(1)),$(word 2,$(dep_$(1))),$(pkg_$(1)_repo)))
  34. dep_commit = $(if $(dep_$(1)_commit),$(dep_$(1)_commit),$(if $(dep_$(1)),$(word 3,$(dep_$(1))),$(pkg_$(1)_commit)))
  35. LOCAL_DEPS_DIRS = $(foreach a,$(LOCAL_DEPS),$(if $(wildcard $(APPS_DIR)/$(a)),$(APPS_DIR)/$(a)))
  36. ALL_APPS_DIRS = $(if $(wildcard $(APPS_DIR)/),$(filter-out $(APPS_DIR),$(shell find $(APPS_DIR) -maxdepth 1 -type d)))
  37. ALL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(foreach dep,$(filter-out $(IGNORE_DEPS),$(BUILD_DEPS) $(DEPS)),$(call dep_name,$(dep))))
  38. ifeq ($(filter $(APPS_DIR) $(DEPS_DIR),$(subst :, ,$(ERL_LIBS))),)
  39. ifeq ($(ERL_LIBS),)
  40. ERL_LIBS = $(APPS_DIR):$(DEPS_DIR)
  41. else
  42. ERL_LIBS := $(ERL_LIBS):$(APPS_DIR):$(DEPS_DIR)
  43. endif
  44. endif
  45. export ERL_LIBS
  46. export NO_AUTOPATCH
  47. # Verbosity.
  48. dep_verbose_0 = @echo " DEP " $(1);
  49. dep_verbose_2 = set -x;
  50. dep_verbose = $(dep_verbose_$(V))
  51. # Core targets.
  52. apps:: $(ALL_APPS_DIRS) clean-tmp-deps.log
  53. ifeq ($(IS_APP)$(IS_DEP),)
  54. $(verbose) rm -f $(ERLANG_MK_TMP)/apps.log
  55. endif
  56. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  57. # Create ebin directory for all apps to make sure Erlang recognizes them
  58. # as proper OTP applications when using -include_lib. This is a temporary
  59. # fix, a proper fix would be to compile apps/* in the right order.
  60. ifndef IS_APP
  61. $(verbose) set -e; for dep in $(ALL_APPS_DIRS) ; do \
  62. mkdir -p $$dep/ebin; \
  63. done
  64. endif
  65. # at the toplevel: if LOCAL_DEPS is defined with at least one local app, only
  66. # compile that list of apps. otherwise, compile everything.
  67. # within an app: compile all LOCAL_DEPS that are (uncompiled) local apps
  68. $(verbose) set -e; for dep in $(if $(LOCAL_DEPS_DIRS)$(IS_APP),$(LOCAL_DEPS_DIRS),$(ALL_APPS_DIRS)) ; do \
  69. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/apps.log; then \
  70. :; \
  71. else \
  72. echo $$dep >> $(ERLANG_MK_TMP)/apps.log; \
  73. $(MAKE) -C $$dep IS_APP=1; \
  74. fi \
  75. done
  76. clean-tmp-deps.log:
  77. ifeq ($(IS_APP)$(IS_DEP),)
  78. $(verbose) rm -f $(ERLANG_MK_TMP)/deps.log
  79. endif
  80. ifneq ($(SKIP_DEPS),)
  81. deps::
  82. else
  83. deps:: $(ALL_DEPS_DIRS) apps clean-tmp-deps.log
  84. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  85. $(verbose) set -e; for dep in $(ALL_DEPS_DIRS) ; do \
  86. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/deps.log; then \
  87. :; \
  88. else \
  89. echo $$dep >> $(ERLANG_MK_TMP)/deps.log; \
  90. if [ -f $$dep/GNUmakefile ] || [ -f $$dep/makefile ] || [ -f $$dep/Makefile ]; then \
  91. $(MAKE) -C $$dep IS_DEP=1; \
  92. else \
  93. echo "Error: No Makefile to build dependency $$dep." >&2; \
  94. exit 2; \
  95. fi \
  96. fi \
  97. done
  98. endif
  99. # Deps related targets.
  100. # @todo rename GNUmakefile and makefile into Makefile first, if they exist
  101. # While Makefile file could be GNUmakefile or makefile,
  102. # in practice only Makefile is needed so far.
  103. define dep_autopatch
  104. if [ -f $(DEPS_DIR)/$(1)/erlang.mk ]; then \
  105. rm -rf $(DEPS_DIR)/$1/ebin/; \
  106. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  107. $(call dep_autopatch_erlang_mk,$(1)); \
  108. elif [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  109. if [ -f $(DEPS_DIR)/$1/rebar.lock ]; then \
  110. $(call dep_autopatch2,$1); \
  111. elif [ 0 != `grep -c "include ../\w*\.mk" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  112. $(call dep_autopatch2,$(1)); \
  113. elif [ 0 != `grep -ci "^[^#].*rebar" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  114. $(call dep_autopatch2,$(1)); \
  115. elif [ -n "`find $(DEPS_DIR)/$(1)/ -type f -name \*.mk -not -name erlang.mk -exec grep -i "^[^#].*rebar" '{}' \;`" ]; then \
  116. $(call dep_autopatch2,$(1)); \
  117. fi \
  118. else \
  119. if [ ! -d $(DEPS_DIR)/$(1)/src/ ]; then \
  120. $(call dep_autopatch_noop,$(1)); \
  121. else \
  122. $(call dep_autopatch2,$(1)); \
  123. fi \
  124. fi
  125. endef
  126. define dep_autopatch2
  127. ! test -f $(DEPS_DIR)/$1/ebin/$1.app || \
  128. mv -n $(DEPS_DIR)/$1/ebin/$1.app $(DEPS_DIR)/$1/src/$1.app.src; \
  129. rm -f $(DEPS_DIR)/$1/ebin/$1.app; \
  130. if [ -f $(DEPS_DIR)/$1/src/$1.app.src.script ]; then \
  131. $(call erlang,$(call dep_autopatch_appsrc_script.erl,$(1))); \
  132. fi; \
  133. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  134. if [ -f $(DEPS_DIR)/$(1)/rebar -o -f $(DEPS_DIR)/$(1)/rebar.config -o -f $(DEPS_DIR)/$(1)/rebar.config.script -o -f $(DEPS_DIR)/$1/rebar.lock ]; then \
  135. $(call dep_autopatch_fetch_rebar); \
  136. $(call dep_autopatch_rebar,$(1)); \
  137. else \
  138. $(call dep_autopatch_gen,$(1)); \
  139. fi
  140. endef
  141. define dep_autopatch_noop
  142. printf "noop:\n" > $(DEPS_DIR)/$(1)/Makefile
  143. endef
  144. # Replace "include erlang.mk" with a line that will load the parent Erlang.mk
  145. # if given. Do it for all 3 possible Makefile file names.
  146. ifeq ($(NO_AUTOPATCH_ERLANG_MK),)
  147. define dep_autopatch_erlang_mk
  148. $t for f in Makefile makefile GNUmakefile; do \
  149. if [ -f $(DEPS_DIR)/$1/$$f ]; then \
  150. sed -i.bak s/'include *erlang.mk'/'include $$(if $$(ERLANG_MK_FILENAME),$$(ERLANG_MK_FILENAME),erlang.mk)'/ $(DEPS_DIR)/$1/$$f; \
  151. fi \
  152. done
  153. endef
  154. else
  155. define dep_autopatch_erlang_mk
  156. :
  157. endef
  158. endif
  159. define dep_autopatch_gen
  160. printf "%s\n" \
  161. "ERLC_OPTS = +debug_info" \
  162. "include ../../erlang.mk" > $(DEPS_DIR)/$(1)/Makefile
  163. endef
  164. define dep_autopatch_fetch_rebar
  165. mkdir -p $(ERLANG_MK_TMP); \
  166. if [ ! -d $(ERLANG_MK_TMP)/rebar ]; then \
  167. git clone -q -n -- https://github.com/rebar/rebar $(ERLANG_MK_TMP)/rebar; \
  168. cd $(ERLANG_MK_TMP)/rebar; \
  169. git checkout -q 576e12171ab8d69b048b827b92aa65d067deea01; \
  170. $(MAKE); \
  171. cd -; \
  172. fi
  173. endef
  174. define dep_autopatch_rebar
  175. if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  176. mv $(DEPS_DIR)/$(1)/Makefile $(DEPS_DIR)/$(1)/Makefile.orig.mk; \
  177. fi; \
  178. $(call erlang,$(call dep_autopatch_rebar.erl,$(1))); \
  179. rm -f $(DEPS_DIR)/$(1)/ebin/$(1).app
  180. endef
  181. define dep_autopatch_rebar.erl
  182. application:load(rebar),
  183. application:set_env(rebar, log_level, debug),
  184. rmemo:start(),
  185. Conf1 = case file:consult("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config)") of
  186. {ok, Conf0} -> Conf0;
  187. _ -> []
  188. end,
  189. {Conf, OsEnv} = fun() ->
  190. case filelib:is_file("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)") of
  191. false -> {Conf1, []};
  192. true ->
  193. Bindings0 = erl_eval:new_bindings(),
  194. Bindings1 = erl_eval:add_binding('CONFIG', Conf1, Bindings0),
  195. Bindings = erl_eval:add_binding('SCRIPT', "$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings1),
  196. Before = os:getenv(),
  197. {ok, Conf2} = file:script("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings),
  198. {Conf2, lists:foldl(fun(E, Acc) -> lists:delete(E, Acc) end, os:getenv(), Before)}
  199. end
  200. end(),
  201. Write = fun (Text) ->
  202. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/Makefile)", Text, [append])
  203. end,
  204. Escape = fun (Text) ->
  205. re:replace(Text, "\\\\$$", "\$$$$", [global, {return, list}])
  206. end,
  207. Write("IGNORE_DEPS += edown eper eunit_formatters meck node_package "
  208. "rebar_lock_deps_plugin rebar_vsn_plugin reltool_util\n"),
  209. Write("C_SRC_DIR = /path/do/not/exist\n"),
  210. Write("C_SRC_TYPE = rebar\n"),
  211. Write("DRV_CFLAGS = -fPIC\nexport DRV_CFLAGS\n"),
  212. Write(["ERLANG_ARCH = ", rebar_utils:wordsize(), "\nexport ERLANG_ARCH\n"]),
  213. fun() ->
  214. Write("ERLC_OPTS = +debug_info\nexport ERLC_OPTS\n"),
  215. case lists:keyfind(erl_opts, 1, Conf) of
  216. false -> ok;
  217. {_, ErlOpts} ->
  218. lists:foreach(fun
  219. ({d, D}) ->
  220. Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  221. ({i, I}) ->
  222. Write(["ERLC_OPTS += -I ", I, "\n"]);
  223. ({platform_define, Regex, D}) ->
  224. case rebar_utils:is_arch(Regex) of
  225. true -> Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  226. false -> ok
  227. end;
  228. ({parse_transform, PT}) ->
  229. Write("ERLC_OPTS += +'{parse_transform, " ++ atom_to_list(PT) ++ "}'\n");
  230. (_) -> ok
  231. end, ErlOpts)
  232. end,
  233. Write("\n")
  234. end(),
  235. fun() ->
  236. File = case lists:keyfind(deps, 1, Conf) of
  237. false -> [];
  238. {_, Deps} ->
  239. [begin case case Dep of
  240. {N, S} when is_atom(N), is_list(S) -> {N, {hex, S}};
  241. {N, S} when is_tuple(S) -> {N, S};
  242. {N, _, S} -> {N, S};
  243. {N, _, S, _} -> {N, S};
  244. _ -> false
  245. end of
  246. false -> ok;
  247. {Name, Source} ->
  248. {Method, Repo, Commit} = case Source of
  249. {hex, V} -> {hex, V, undefined};
  250. {git, R} -> {git, R, master};
  251. {M, R, {branch, C}} -> {M, R, C};
  252. {M, R, {ref, C}} -> {M, R, C};
  253. {M, R, {tag, C}} -> {M, R, C};
  254. {M, R, C} -> {M, R, C}
  255. end,
  256. Write(io_lib:format("DEPS += ~s\ndep_~s = ~s ~s ~s~n", [Name, Name, Method, Repo, Commit]))
  257. end end || Dep <- Deps]
  258. end
  259. end(),
  260. fun() ->
  261. case lists:keyfind(erl_first_files, 1, Conf) of
  262. false -> ok;
  263. {_, Files} ->
  264. Names = [[" ", case lists:reverse(F) of
  265. "lre." ++ Elif -> lists:reverse(Elif);
  266. Elif -> lists:reverse(Elif)
  267. end] || "src/" ++ F <- Files],
  268. Write(io_lib:format("COMPILE_FIRST +=~s\n", [Names]))
  269. end
  270. end(),
  271. Write("\n\nrebar_dep: preprocess pre-deps deps pre-app app\n"),
  272. Write("\npreprocess::\n"),
  273. Write("\npre-deps::\n"),
  274. Write("\npre-app::\n"),
  275. PatchHook = fun(Cmd) ->
  276. case Cmd of
  277. "make -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  278. "gmake -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  279. "make " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  280. "gmake " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  281. _ -> Escape(Cmd)
  282. end
  283. end,
  284. fun() ->
  285. case lists:keyfind(pre_hooks, 1, Conf) of
  286. false -> ok;
  287. {_, Hooks} ->
  288. [case H of
  289. {'get-deps', Cmd} ->
  290. Write("\npre-deps::\n\t" ++ PatchHook(Cmd) ++ "\n");
  291. {compile, Cmd} ->
  292. Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  293. {Regex, compile, Cmd} ->
  294. case rebar_utils:is_arch(Regex) of
  295. true -> Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  296. false -> ok
  297. end;
  298. _ -> ok
  299. end || H <- Hooks]
  300. end
  301. end(),
  302. ShellToMk = fun(V) ->
  303. re:replace(re:replace(V, "(\\\\$$)(\\\\w*)", "\\\\1(\\\\2)", [global]),
  304. "-Werror\\\\b", "", [{return, list}, global])
  305. end,
  306. PortSpecs = fun() ->
  307. case lists:keyfind(port_specs, 1, Conf) of
  308. false ->
  309. case filelib:is_dir("$(call core_native_path,$(DEPS_DIR)/$1/c_src)") of
  310. false -> [];
  311. true ->
  312. [{"priv/" ++ proplists:get_value(so_name, Conf, "$(1)_drv.so"),
  313. proplists:get_value(port_sources, Conf, ["c_src/*.c"]), []}]
  314. end;
  315. {_, Specs} ->
  316. lists:flatten([case S of
  317. {Output, Input} -> {ShellToMk(Output), Input, []};
  318. {Regex, Output, Input} ->
  319. case rebar_utils:is_arch(Regex) of
  320. true -> {ShellToMk(Output), Input, []};
  321. false -> []
  322. end;
  323. {Regex, Output, Input, [{env, Env}]} ->
  324. case rebar_utils:is_arch(Regex) of
  325. true -> {ShellToMk(Output), Input, Env};
  326. false -> []
  327. end
  328. end || S <- Specs])
  329. end
  330. end(),
  331. PortSpecWrite = fun (Text) ->
  332. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/c_src/Makefile.erlang.mk)", Text, [append])
  333. end,
  334. case PortSpecs of
  335. [] -> ok;
  336. _ ->
  337. Write("\npre-app::\n\t$$\(MAKE) -f c_src/Makefile.erlang.mk\n"),
  338. PortSpecWrite(io_lib:format("ERL_CFLAGS ?= -finline-functions -Wall -fPIC -I \\"~s/erts-~s/include\\" -I \\"~s\\"\n",
  339. [code:root_dir(), erlang:system_info(version), code:lib_dir(erl_interface, include)])),
  340. PortSpecWrite(io_lib:format("ERL_LDFLAGS ?= -L \\"~s\\" -lerl_interface -lei\n",
  341. [code:lib_dir(erl_interface, lib)])),
  342. [PortSpecWrite(["\n", E, "\n"]) || E <- OsEnv],
  343. FilterEnv = fun(Env) ->
  344. lists:flatten([case E of
  345. {_, _} -> E;
  346. {Regex, K, V} ->
  347. case rebar_utils:is_arch(Regex) of
  348. true -> {K, V};
  349. false -> []
  350. end
  351. end || E <- Env])
  352. end,
  353. MergeEnv = fun(Env) ->
  354. lists:foldl(fun ({K, V}, Acc) ->
  355. case lists:keyfind(K, 1, Acc) of
  356. false -> [{K, rebar_utils:expand_env_variable(V, K, "")}|Acc];
  357. {_, V0} -> [{K, rebar_utils:expand_env_variable(V, K, V0)}|Acc]
  358. end
  359. end, [], Env)
  360. end,
  361. PortEnv = case lists:keyfind(port_env, 1, Conf) of
  362. false -> [];
  363. {_, PortEnv0} -> FilterEnv(PortEnv0)
  364. end,
  365. PortSpec = fun ({Output, Input0, Env}) ->
  366. filelib:ensure_dir("$(call core_native_path,$(DEPS_DIR)/$1/)" ++ Output),
  367. Input = [[" ", I] || I <- Input0],
  368. PortSpecWrite([
  369. [["\n", K, " = ", ShellToMk(V)] || {K, V} <- lists:reverse(MergeEnv(PortEnv))],
  370. case $(PLATFORM) of
  371. darwin -> "\n\nLDFLAGS += -flat_namespace -undefined suppress";
  372. _ -> ""
  373. end,
  374. "\n\nall:: ", Output, "\n\n",
  375. "%.o: %.c\n\t$$\(CC) -c -o $$\@ $$\< $$\(CFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  376. "%.o: %.C\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  377. "%.o: %.cc\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  378. "%.o: %.cpp\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  379. [[Output, ": ", K, " += ", ShellToMk(V), "\n"] || {K, V} <- lists:reverse(MergeEnv(FilterEnv(Env)))],
  380. Output, ": $$\(foreach ext,.c .C .cc .cpp,",
  381. "$$\(patsubst %$$\(ext),%.o,$$\(filter %$$\(ext),$$\(wildcard", Input, "))))\n",
  382. "\t$$\(CC) -o $$\@ $$\? $$\(LDFLAGS) $$\(ERL_LDFLAGS) $$\(DRV_LDFLAGS) $$\(EXE_LDFLAGS)",
  383. case {filename:extension(Output), $(PLATFORM)} of
  384. {[], _} -> "\n";
  385. {_, darwin} -> "\n";
  386. _ -> " -shared\n"
  387. end])
  388. end,
  389. [PortSpec(S) || S <- PortSpecs]
  390. end,
  391. Write("\ninclude $$\(if $$\(ERLANG_MK_FILENAME),$$\(ERLANG_MK_FILENAME),erlang.mk)"),
  392. RunPlugin = fun(Plugin, Step) ->
  393. case erlang:function_exported(Plugin, Step, 2) of
  394. false -> ok;
  395. true ->
  396. c:cd("$(call core_native_path,$(DEPS_DIR)/$1/)"),
  397. Ret = Plugin:Step({config, "", Conf, dict:new(), dict:new(), dict:new(),
  398. dict:store(base_dir, "", dict:new())}, undefined),
  399. io:format("rebar plugin ~p step ~p ret ~p~n", [Plugin, Step, Ret])
  400. end
  401. end,
  402. fun() ->
  403. case lists:keyfind(plugins, 1, Conf) of
  404. false -> ok;
  405. {_, Plugins} ->
  406. [begin
  407. case lists:keyfind(deps, 1, Conf) of
  408. false -> ok;
  409. {_, Deps} ->
  410. case lists:keyfind(P, 1, Deps) of
  411. false -> ok;
  412. _ ->
  413. Path = "$(call core_native_path,$(DEPS_DIR)/)" ++ atom_to_list(P),
  414. io:format("~s", [os:cmd("$(MAKE) -C $(call core_native_path,$(DEPS_DIR)/$1) " ++ Path)]),
  415. io:format("~s", [os:cmd("$(MAKE) -C " ++ Path ++ " IS_DEP=1")]),
  416. code:add_patha(Path ++ "/ebin")
  417. end
  418. end
  419. end || P <- Plugins],
  420. [case code:load_file(P) of
  421. {module, P} -> ok;
  422. _ ->
  423. case lists:keyfind(plugin_dir, 1, Conf) of
  424. false -> ok;
  425. {_, PluginsDir} ->
  426. ErlFile = "$(call core_native_path,$(DEPS_DIR)/$1/)" ++ PluginsDir ++ "/" ++ atom_to_list(P) ++ ".erl",
  427. {ok, P, Bin} = compile:file(ErlFile, [binary]),
  428. {module, P} = code:load_binary(P, ErlFile, Bin)
  429. end
  430. end || P <- Plugins],
  431. [RunPlugin(P, preprocess) || P <- Plugins],
  432. [RunPlugin(P, pre_compile) || P <- Plugins],
  433. [RunPlugin(P, compile) || P <- Plugins]
  434. end
  435. end(),
  436. halt()
  437. endef
  438. define dep_autopatch_appsrc_script.erl
  439. AppSrc = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  440. AppSrcScript = AppSrc ++ ".script",
  441. Bindings = erl_eval:new_bindings(),
  442. {ok, Conf} = file:script(AppSrcScript, Bindings),
  443. ok = file:write_file(AppSrc, io_lib:format("~p.~n", [Conf])),
  444. halt()
  445. endef
  446. define dep_autopatch_appsrc.erl
  447. AppSrcOut = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  448. AppSrcIn = case filelib:is_regular(AppSrcOut) of false -> "$(call core_native_path,$(DEPS_DIR)/$1/ebin/$1.app)"; true -> AppSrcOut end,
  449. case filelib:is_regular(AppSrcIn) of
  450. false -> ok;
  451. true ->
  452. {ok, [{application, $(1), L0}]} = file:consult(AppSrcIn),
  453. L1 = lists:keystore(modules, 1, L0, {modules, []}),
  454. L2 = case lists:keyfind(vsn, 1, L1) of {_, git} -> lists:keyreplace(vsn, 1, L1, {vsn, "git"}); _ -> L1 end,
  455. L3 = case lists:keyfind(registered, 1, L2) of false -> [{registered, []}|L2]; _ -> L2 end,
  456. ok = file:write_file(AppSrcOut, io_lib:format("~p.~n", [{application, $(1), L3}])),
  457. case AppSrcOut of AppSrcIn -> ok; _ -> ok = file:delete(AppSrcIn) end
  458. end,
  459. halt()
  460. endef
  461. define dep_fetch_git
  462. git clone -q -n -- $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  463. cd $(DEPS_DIR)/$(call dep_name,$(1)) && git checkout -q $(call dep_commit,$(1));
  464. endef
  465. define dep_fetch_git-submodule
  466. git submodule update --init -- $(DEPS_DIR)/$1;
  467. endef
  468. define dep_fetch_hg
  469. hg clone -q -U $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  470. cd $(DEPS_DIR)/$(call dep_name,$(1)) && hg update -q $(call dep_commit,$(1));
  471. endef
  472. define dep_fetch_svn
  473. svn checkout -q $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  474. endef
  475. define dep_fetch_cp
  476. cp -R $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  477. endef
  478. define dep_fetch_ln
  479. ln -s $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  480. endef
  481. # Hex only has a package version. No need to look in the Erlang.mk packages.
  482. define dep_fetch_hex
  483. mkdir -p $(ERLANG_MK_TMP)/hex $(DEPS_DIR)/$1; \
  484. $(call core_http_get,$(ERLANG_MK_TMP)/hex/$1.tar,\
  485. https://s3.amazonaws.com/s3.hex.pm/tarballs/$1-$(strip $(word 2,$(dep_$1))).tar); \
  486. tar -xOf $(ERLANG_MK_TMP)/hex/$1.tar contents.tar.gz | tar -C $(DEPS_DIR)/$1 -xzf -;
  487. endef
  488. define dep_fetch_fail
  489. echo "Error: Unknown or invalid dependency: $(1)." >&2; \
  490. exit 78;
  491. endef
  492. # Kept for compatibility purposes with older Erlang.mk configuration.
  493. define dep_fetch_legacy
  494. $(warning WARNING: '$(1)' dependency configuration uses deprecated format.) \
  495. git clone -q -n -- $(word 1,$(dep_$(1))) $(DEPS_DIR)/$(1); \
  496. cd $(DEPS_DIR)/$(1) && git checkout -q $(if $(word 2,$(dep_$(1))),$(word 2,$(dep_$(1))),master);
  497. endef
  498. define dep_fetch
  499. $(if $(dep_$(1)), \
  500. $(if $(dep_fetch_$(word 1,$(dep_$(1)))), \
  501. $(word 1,$(dep_$(1))), \
  502. $(if $(IS_DEP),legacy,fail)), \
  503. $(if $(filter $(1),$(PACKAGES)), \
  504. $(pkg_$(1)_fetch), \
  505. fail))
  506. endef
  507. define dep_target
  508. $(DEPS_DIR)/$(call dep_name,$1):
  509. $(eval DEP_NAME := $(call dep_name,$1))
  510. $(eval DEP_STR := $(if $(filter-out $1,$(DEP_NAME)),$1,"$1 ($(DEP_NAME))"))
  511. $(verbose) if test -d $(APPS_DIR)/$(DEP_NAME); then \
  512. echo "Error: Dependency" $(DEP_STR) "conflicts with application found in $(APPS_DIR)/$(DEP_NAME)." >&2; \
  513. exit 17; \
  514. fi
  515. $(verbose) mkdir -p $(DEPS_DIR)
  516. $(dep_verbose) $(call dep_fetch_$(strip $(call dep_fetch,$(1))),$(1))
  517. $(verbose) if [ -f $(DEPS_DIR)/$(1)/configure.ac -o -f $(DEPS_DIR)/$(1)/configure.in ] \
  518. && [ ! -f $(DEPS_DIR)/$(1)/configure ]; then \
  519. echo " AUTO " $(1); \
  520. cd $(DEPS_DIR)/$(1) && autoreconf -Wall -vif -I m4; \
  521. fi
  522. - $(verbose) if [ -f $(DEPS_DIR)/$(DEP_NAME)/configure ]; then \
  523. echo " CONF " $(DEP_STR); \
  524. cd $(DEPS_DIR)/$(DEP_NAME) && ./configure; \
  525. fi
  526. ifeq ($(filter $(1),$(NO_AUTOPATCH)),)
  527. $(verbose) if [ "$(1)" = "amqp_client" -a "$(RABBITMQ_CLIENT_PATCH)" ]; then \
  528. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  529. echo " PATCH Downloading rabbitmq-codegen"; \
  530. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  531. fi; \
  532. if [ ! -d $(DEPS_DIR)/rabbitmq-server ]; then \
  533. echo " PATCH Downloading rabbitmq-server"; \
  534. git clone https://github.com/rabbitmq/rabbitmq-server.git $(DEPS_DIR)/rabbitmq-server; \
  535. fi; \
  536. ln -s $(DEPS_DIR)/amqp_client/deps/rabbit_common-0.0.0 $(DEPS_DIR)/rabbit_common; \
  537. elif [ "$(1)" = "rabbit" -a "$(RABBITMQ_SERVER_PATCH)" ]; then \
  538. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  539. echo " PATCH Downloading rabbitmq-codegen"; \
  540. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  541. fi \
  542. else \
  543. $$(call dep_autopatch,$(DEP_NAME)) \
  544. fi
  545. endif
  546. endef
  547. $(foreach dep,$(BUILD_DEPS) $(DEPS),$(eval $(call dep_target,$(dep))))
  548. ifndef IS_APP
  549. clean:: clean-apps
  550. clean-apps:
  551. $(verbose) set -e; for dep in $(ALL_APPS_DIRS) ; do \
  552. $(MAKE) -C $$dep clean IS_APP=1; \
  553. done
  554. distclean:: distclean-apps
  555. distclean-apps:
  556. $(verbose) set -e; for dep in $(ALL_APPS_DIRS) ; do \
  557. $(MAKE) -C $$dep distclean IS_APP=1; \
  558. done
  559. endif
  560. ifndef SKIP_DEPS
  561. distclean:: distclean-deps
  562. distclean-deps:
  563. $(gen_verbose) rm -rf $(DEPS_DIR)
  564. endif
  565. # Forward-declare variables used in core/deps-tools.mk. This is required
  566. # in case plugins use them.
  567. ERLANG_MK_RECURSIVE_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-deps-list.log
  568. ERLANG_MK_RECURSIVE_DOC_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-doc-deps-list.log
  569. ERLANG_MK_RECURSIVE_REL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-rel-deps-list.log
  570. ERLANG_MK_RECURSIVE_TEST_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-test-deps-list.log
  571. ERLANG_MK_RECURSIVE_SHELL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-shell-deps-list.log